<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TypeAnalyserAndTranslator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.umlparser;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.type.Type;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <em class="jxr_javadoccomment"> * Allows to analyse an ast type, and to translate it according to recognized</em>
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <em class="jxr_javadoccomment"> * patterns.</em>
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <em class="jxr_javadoccomment"> * For example, this allow to translate from List&lt;Xxx&gt; to Xxx[0..1].</em>
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <em class="jxr_javadoccomment"> * TODO : improve to take into account Map, Set, ...</em>
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <em class="jxr_javadoccomment"> * Use an enum rather than a boolean. Allow to create association class specifying the real type used.</em>
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <em class="jxr_javadoccomment"> * @author dumoulin</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">TypeAnalyserAndTranslator</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyser.html">TypeAnalyser</a> {
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  	<strong class="jxr_keyword">private</strong> List&lt;List&lt;String&gt;&gt; translationList = <strong class="jxr_keyword">new</strong> ArrayList&lt;List&lt;String&gt;&gt;();
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String[] defaultTranslatedType = {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  			<span class="jxr_string">"java.util.List"</span>,
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  			<span class="jxr_string">"java.util.ArrayList"</span>,
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  			<span class="jxr_string">"java.util.Collection"</span>,
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  			<span class="jxr_string">"java.util.OrderedSet"</span>,
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  	};
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">	 * Constructor.</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment">	 * @param importedType</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">TypeAnalyserAndTranslator</a>(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/ImportedTypeCatalog.html">ImportedTypeCatalog</a> importedType) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  		<strong class="jxr_keyword">super</strong>(importedType);
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		initDefaultTranslatedTypes(defaultTranslatedType);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	}
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 * Get the translated type data from the astType.</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * @param astType</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">TranslatedTypeData</a> getTranslatedTypeData(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/type/Type.html">Type</a> astType) {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		TranslatedTypeData typeData = (TranslatedTypeData) getTypeData(astType);
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		<em class="jxr_comment">// Does the type correspond to a list ?</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		translate(typeData);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">return</strong> typeData;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 * Return the TRanslatedTypeData</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  	@Override
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyser.html">TypeData</a> createTypeData() {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">TranslatedTypeData</a>();
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  	}
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 * Translate the type if it is a collection type.</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 * @param data</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> translate(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">TranslatedTypeData</a> data) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		List&lt;String&gt; qname = data.qualifiedName;
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">if</strong> (translationList.contains(qname)) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			<em class="jxr_comment">// Check for one and only one template parameter</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			<strong class="jxr_keyword">if</strong> (data.genericData != <strong class="jxr_keyword">null</strong> &amp;&amp; data.genericData.size() == 1) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  				System.out.println(<span class="jxr_string">"translate '"</span> + qname + <span class="jxr_string">"'"</span>);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				<em class="jxr_comment">// Set translatable if it is a valide inner type (i.e. not a wildcard)</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  				<strong class="jxr_keyword">if</strong> (!data.genericData.get(0).isWildcard) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  					data.isTranslatable = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  				}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  				data.isCollection = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (data.genericData == <strong class="jxr_keyword">null</strong>) { <em class="jxr_comment">// Collection type, with nospecified type :-(</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  				data.isCollection = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			}
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (data.arrayCount &gt; 0) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			data.isCollection = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		}
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		<em class="jxr_comment">// not translatable</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  	}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 * Data structure returned</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 * @author dumoulin</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyserAndTranslator.html">TranslatedTypeData</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/TypeAnalyser.html">TypeData</a> {
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<em class="jxr_javadoccomment">/** is the type translatable (can we use the generic's one) ? */</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isTranslatable = false;
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<em class="jxr_javadoccomment">/** is the type denoting a collection ? */</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isCollection = false;
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">		 * Get the Real name, taking into account if it is a generic.</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_javadoccomment">		 *</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> <em class="jxr_javadoccomment">		 * @return</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<strong class="jxr_keyword">public</strong> List&lt;String&gt; getTranslatedQualifiedName() {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			<strong class="jxr_keyword">if</strong> (isTranslatable) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 				<strong class="jxr_keyword">return</strong> genericData.get(0).qualifiedName;
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 				<strong class="jxr_keyword">return</strong> qualifiedName;
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 			}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getTranslatedUpper() {
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			<strong class="jxr_keyword">if</strong> (isCollection) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				<strong class="jxr_keyword">return</strong> -1;
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 				<strong class="jxr_keyword">return</strong> 1;
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 			}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		}
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getTranslatedLower() {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 			<strong class="jxr_keyword">if</strong> (isCollection) {
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 				<strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 				<strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			}
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		}
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isCollection() {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			<strong class="jxr_keyword">return</strong> isCollection;
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 	}
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * Set the default mappings</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 * @param defaultMappingNames</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> initDefaultTranslatedTypes(String[] defaultTranslatedTypes) {
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; defaultTranslatedTypes.length; i++) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 			translationList.add(UmlUtils.toQualifiedName(defaultTranslatedTypes[i]));
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		}
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 	}
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 
<a class="jxr_linenumber" name="L154" href="#L154">154</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
